services:
    # default configuration for services in *this* file
    _defaults:
        autowire: true      # Automatically injects dependencies in your services.
        autoconfigure: true # Automatically registers your services as commands, event subscribers, etc.

    # makes classes in src/ available to be used as services
    # this creates a service per class whose id is the fully-qualified class name
    Air\Core\Api\:
        resource: '../../*'
        exclude: '../../Admin,DependencyInjection,Entity,Migrations,Tests,Kernel.php}'

    # controllers are imported separately to make sure services can be injected
    # as action arguments even if you don't extend any base controller class
    Air\Core\Api\Controller\:
        resource: '../../Controller'
        tags: ['controller.service_arguments']

    Gesdinet\JWTRefreshTokenBundle\Service\RefreshToken:
        alias: gesdinet.jwtrefreshtoken

    app.event.jwt_success_listener:
        class: Air\Core\Api\EventSubscriber\Jwt\AuthenticationSuccessListener
        arguments:
            $serializer: '@jms_serializer'
            $tokenTtl: '%env(JWT_TOKEN_TTL)%'
            $refreshTokenTtl: '%env(JWT_REFRESH_TOKEN_TTL)%'
        tags:
            - { name: kernel.event_listener, event: lexik_jwt_authentication.on_authentication_success, method: onAuthenticationSuccessResponse, priority: -1}

    app.event.jwt_failure_listener:
        class: Air\Core\Api\EventSubscriber\Jwt\AuthenticationFailureListener
        tags:
            - { name: kernel.event_listener, event: lexik_jwt_authentication.on_authentication_failure, method: onAuthenticationFailureResponse }
            - { name: kernel.event_listener, event: lexik_jwt_authentication.on_jwt_invalid, method: onJWTInvalid }
            - { name: kernel.event_listener, event: lexik_jwt_authentication.on_jwt_not_found, method: onJWTNotFound }
            - { name: kernel.event_listener, event: lexik_jwt_authentication.on_jwt_expired, method: onJWTExpired }

    Air\Core\Api\Service\Form\FormErrorListGenerator:
        public: true

    app.api.redis.provider:
        class: \Redis
        factory: ['Symfony\Component\Cache\Adapter\RedisAdapter', 'createConnection']
        arguments:
            - '%env(REDIS_URL)%'
            - { retry_interval: 2, timeout: 10 }

    Air\Core\Api\Service\Cache\ApiRedisCache:
        arguments:
          - '@app.api.redis.provider'
          - 'api.v1'
          - '86400'
          - '%env(API_CACHE_ENABLED)%'
        tags:
            - { name: 'cache.pool', provider: 'app.api.redis.provider', namespace: 'api.v1'}
            - { name: 'monolog.logger', channel: 'cache' }

    Air\Core\Api\EventSubscriber\CacheSubscriber:
        arguments:
          - '@doctrine.orm.entity_manager'
          - '@Air\Core\Api\Service\Cache\ApiRedisCache'
        tags:
          - { name: doctrine.event_subscriber, connection: default }
